<h1>Checking file permissions</h1>
<BR>
note: Only errors will be output. So, no output is good.<BR><BR>

<?

include_once "config.inc.php";


$starttime= microtime(); 
// calculate time that was needed for execution
// irt.org rules hardcore!
function timetaken($type="") {
global $starttime;
	$endtime = microtime(); 
	$parts_of_starttime = explode(' ', $starttime); 
	$starttime = $parts_of_starttime[0];
	if (isset($parts_of_starttime[1])) {
		$starttime += $parts_of_starttime[1]; 
	}
	$parts_of_endtime = explode(' ', $endtime); 
	$endtime= $parts_of_endtime[0] + $parts_of_endtime[1]; 
	$time_taken = $endtime - $starttime;
	$time_taken= number_format($time_taken, 2);  // optional

	if ($type=="int") {
		return $time_taken;
	} else {
		return "<span class='timetaken'>$time_taken</span>";
	}
}



function get_fileperms($dirname) {

	$perms=fileperms($dirname);
	$perms = sprintf("%o",$perms);
	$perms= substr($perms,-3);
	return $perms;
}

function get_owner($name) {
	// does not work properly yet.
	// needs to check for current user as well :-/

	//$owner=fileowner($name);
}

function test_dir_exists($dirname) {

	if (file_exists($dirname)) {
		return true;
	} else {
		echo "Folder '<B>$dirname</B>' does not exist.<BR>";
		return FALSE;
	}
	
}

function test_dir_writeable($dirname) {

	if(!test_dir_exists($dirname)) {
		return;
	}

	$perms = get_fileperms($dirname);

	if ($perms=="777") {
		//echo "Folder '$dirname' is ok: $perms.<BR>";
		return TRUE;
	} else { 
		echo "Folder '<B>$dirname</B>' is not writable.<BR>";
		return FALSE;
	}
}



function test_file_exists($filename, $silent=FALSE) {

	if (file_exists($filename)) {
		return true;
	} else if (!$silent) {
		echo "File '<B>$filename</B>' does not exist.<BR>";
		return FALSE;
	}
		
}

function test_file_writeable($filename, $silent=FALSE) {

	if(!test_file_exists($filename, $silent)) {
		return;
	}

	$perms = get_fileperms($filename);
	

	if ($perms>="766") {
		//echo "File '$filename' is ok: $perms.<BR>";
		return TRUE;
	} else { 
		get_owner($filename);
		echo "File '<B>$filename</B>' is not writable.<BR>";
		return FALSE;
	}
}

function recur_test($dirname) {
	$d= dir($dirname);
	while($entry=$d->read()) {
		//echo $entry."<br>\n";
		if ( ($entry=='.') || ($entry=='..') ) {
			continue;
		}
		
		if (is_dir('db/'.$entry)) {
			if(test_dir_writeable($dirname.'/'.$entry)) {
				recur_test($dirname.'/'.$entry);
			}
		} else {
			test_file_writeable($dirname.'/'.$entry) ;
		}
	}
	
	$d->close();
}



//



test_dir_writeable($global_pref['local_path']);

test_dir_writeable($global_pref['local_path'].$global_pref['upload_path']);

test_file_writeable('../link_list.html', TRUE);
test_file_writeable('../'.$global_pref['index'], TRUE);
test_file_writeable('../archive_list.html', TRUE);

test_file_writeable('config.inc.php');

test_file_writeable('users.php');


if (test_dir_writeable('db')) {
	//echo "db/ schrijfbaar<br>\n";
	recur_test('db');

}

if (test_dir_writeable('templates')) {
	//echo "templates/ schrijfbaar<br>\n";
	recur_test('templates');

}


echo "<BR><BR>Done! (in ".timetaken()." seconds)";


?>