<?

// ============================================================
// Global Initialisation goes here..
// ============================================================

session_start();

include_once("users.php");
include_once("xmlfile.php");
include_once("db_xml.php");
include_once("module_ipblock.php");

$version="0.12";

if ($global_pref['debug']=="yes") {
//	error_reporting (E_ERROR | E_WARNING | E_PARSE | E_NOTICE);
	error_reporting (E_ALL);
} else {
	error_reporting  (E_ERROR | E_PARSE);
}

set_magic_quotes_runtime(0);
combine_parameters();

// set the env. vars if php version > 4.2.0 
if (check_php_version('4.2.0')) {
	$PHP_SELF=$_SERVER['PHP_SELF'];
	$REMOTE_ADDR=$_SERVER['REMOTE_ADDR'];
	$HTTP_USER_AGENT=$_SERVER['HTTP_USER_AGENT'];
	$HTTP_SESSION_VARS=$_SESSION;

}



$remote=$REMOTE_ADDR;
$agent=$HTTP_USER_AGENT;
$current_date=date("Y-m-d-H-i", get_current_date());
$log_date=date("Y:m:d - H:i");
$starttime= microtime(); 


// Xitami does not support ['path_info'], so we set it for those users.
if (!(isset($HTTP_SERVER_VARS['PATH_INFO'])) || (strlen($HTTP_SERVER_VARS['PATH_INFO'])<2) ) { 
	if ( (isset($HTTP_SERVER_VARS['SCRIPT_NAME'])) && (strlen($HTTP_SERVER_VARS['SCRIPT_NAME'])>2) ) { 
		$HTTP_SERVER_VARS['PATH_INFO']=$HTTP_SERVER_VARS['SCRIPT_NAME']; 
	}
}
$current_path = (isset($HTTP_SERVER_VARS['PATH_INFO'])) ? $HTTP_SERVER_VARS['PATH_INFO'] : $HTTP_SERVER_VARS['PHP_SELF'];

$global_pref['pivot_dir']= basename(dirname($current_path))."/";

$global_pref['pivot_url']= dirname($current_path)."/";
if (strpos($global_pref['pivot_url'], "php.exe") > 0) { 
	$global_pref['pivot_url']= substr($global_pref['pivot_url'], strpos($global_pref['pivot_url'], "php.exe")+7); 
}


$global_pref['log_url']= dirname(dirname($current_path))."/";
$global_pref['log_url']=str_replace("\\", "", $global_pref['log_url']);
if (strpos($global_pref['log_url'], "php.exe") > 0) { 
	$global_pref['log_url']= substr($global_pref['log_url'], strpos($global_pref['log_url'], "php.exe")+7); 
}

//debug("pivot_url: ".$global_pref['pivot_url']);
//debug("log_url: ".$global_pref['pivot_url']);

$global_pref['host']="http://".$HTTP_SERVER_VARS['HTTP_HOST'];

if ($global_pref['log_url']=="//")  { $global_pref['log_url']="/"; }

if (!isset($global_pref['live_comments'])) {
	$global_pref['live_comments']= TRUE;
}

if (!isset($global_pref['ssi_prefix'])) {
	$global_pref['ssi_prefix']="";
}

$global_pref['commentsarr']=explode("|",$global_pref['comments']);
$global_pref['comments_numbersarr']=explode("|",$global_pref['comments_numbers']);


// a 'nobody user', for use when a reference is being made to a
// non-existing user.
$global_user['nobody']['password']="";
$global_user['nobody']['nickname']="Nobody";
$global_user['nobody']['email']="";
$global_user['nobody']['admin']="no";

if (!isset($global_pref['emoticons'])) {
	$global_pref['emoticons']=FALSE;

}
// check if user is logged in. If not, kick him/her to the index-page..
/*
if (isset($HTTP_SESSION_VARS["current_user"])) {
	$username=$HTTP_SESSION_VARS["current_user"];
	$current_user=$HTTP_SESSION_VARS["current_user"];
	$current_user_path=$HTTP_SESSION_VARS['current_user_path'];
	$current_user_nickname=$HTTP_SESSION_VARS['current_user_nickname'];
	$current_user_email=$HTTP_SESSION_VARS['current_user_email'];
	$current_user_admin=$HTTP_SESSION_VARS['current_user_admin'];
}
*/

if (!isset($PIV_COOKIES['current_user'])) { 
	if ( (isset($skip_login))  && ($skip_login=="yes") ) {
		// no authentication req.
		$user['name']="";
	} else {
		redirect("index.php?m=You%20are%20not%20Authenticated"); 
	}
} else {
	if (!($PIV_COOKIES["current_user_path"]==$global_pref['pivot_url'])) {
		//debug("1:".$PIV_COOKIES["current_user_path"]);
		//debug("1:".$global_pref['pivot_url']);
		if ( (isset($global_pref['check_session_hijaack'])) && $global_pref['check_session_hijaack'] ) {
			redirect("index.php?m=No%20Session%20Hijaacking!!"); 
		}
	}
	$user['name']=$PIV_COOKIES["current_user"];
	$user['nickname']=$PIV_COOKIES["current_user_nickname"];
	$user['email']=$PIV_COOKIES["current_user_email"];
	$user['admin']=$PIV_COOKIES["current_user_admin"];
	$user['password']="";
}


// To encode funny characters like  to &eacute; we use
// the standard php-functions. 
$encode_html=get_html_translation_table(HTML_ENTITIES);

// unfortunately, these are not complete, so we add some more..
$encode_html['']="&#0145;";
$encode_html['']="&#0146;";
$encode_html['']="&#0130;";
$encode_html['']="&#0147;";
$encode_html['']="&#0148;";
$encode_html['']="&#0153;";
$encode_html['']="&oelig;";
$encode_html['']="&euro;";
//$encode_html['']="";

// The array to translate entities to funny characters..
$decode_html=array_flip($encode_html);     

// if emoticons is set, initialize them
if ($global_pref['emoticons']=="yes") {
	init_emoticons();
}


// ============================================================
// functions start here..
// ============================================================

// check if a submitted password is ok..
function password_ok($user, $pass){
global $global_user;

//	debug ("in: $user, $pass");
//	debug ("leng:".count($global_user));
//	debug ("pass: ".$global_user[$user]['password']);
	if (isset($global_user[$user]['password'])) {
		return ( ($user!="") && ($pass!="") && ($global_user[$user]['password']==md5($pass) ) );
	} else {
		return false;
	}

}

function check_user_admin($real_admin="") {
global $global_user, $user;

	if ( ($user['name']!="admin") && ($real_admin!="") ) {
		piv_error("Admins only!", "You need to be logged as <b>the user admin<b> to do that, not just as a user with admin rights. <br><br>Go <a href='javascript:history.go(-1)'>back</a> to the last page, and do something else.", 0);
	}

	if ($user['admin']!="yes") {
		debug("niet admin: ".$user['name']);
		piv_error("Admins only!", "You need to be logged in as an admin to do that. <br><br>Go <a href='javascript:history.go(-1)'>back</a> to the last page, and do something else.", 0);
	}
}


function check_login_or_cookie() {
global $user,$cookie_user, $cookie_pass, $HTTP_SESSION_VARS, $PIV_COOKIES;	

	//echo "<pre>";
	//print_r($PIV_COOKIES);
	//echo "</pre>";

	if ( (!isset($user['name']))  ) {
		debug("logged in");
		return true;
	}

	if (isset($HTTP_SESSION_VARS["current_user"])) {
		//debug("logged in..");
		return true;
	}

	if ( isset($PIV_COOKIES['cookie_user']) && isset($PIV_COOKIES['cookie_pass']) ) {
		debug("cookies will do.");
		$user['name']=$PIV_COOKIES['cookie_user'];
		$user['password']=$PIV_COOKIES['cookie_pass'];
		return true;
	} else {
		return false;
	}

}


// piv_error prints a fancy error message.. for dweebs that try to do
// stuff they shouldn't
function piv_error($name, $message, $menu=1){

	echo "<HTML><HEAD><TITLE>Pivot: Error</TITLE>\n<STYLE>\n@import url(extra/pivot.css);\n</STYLE>\n</HEAD>\n<BODY>\n";
	if ($menu==1) {
		include "extra/cmt_inc/mainmenu.html";
	} else {
		include "extra/cmt_inc/nomenu.html";

	}
	echo "<h1>$name</h1>\n\n";
	echo "<div class='extrapadding2' style='width:400px;'>$message</div>";
	echo "</body></HTML>\n";
	die();
}

// redirect. first through header, otherwise by javascript..
function redirect($url, $rand = 0, $die=1, $js=0) {
global $global_pref;

	// change the redirect to a full url. Some browsers/webservers need this..

	if ($global_pref['redirect']=="absolute") {
		$url=$global_pref['pivot_url'].$url;
		echo " ";
	}

	// to make sure the visitor gets to see the new page, we redirect with a dummy parameter..
	if ($rand==1) {
		srand ((double) microtime() * 1000000);
		$randval = rand();
	    $url.="?".$randval;
	}

	if ($global_pref['debug']=="yes") {
		echo "<a href=\"$url\">$url</a>";
		if ($die==1) { die(); } else { echo "don't die"; }
	} else {
		header("Location: ".$url);
		echo "<script>self.location='$url';</script>";
		if ($die==1) { die(); } else { echo "don't die"; }
	}

}

// import some vars into a piv_para, so it's nice and safe, and works both under php < 4.2 and php ? 4.2
function combine_parameters() {

	global $PIV_PARA, $PIV_COOKIES, $HTTP_GET_VARS , $HTTP_POST_VARS, $HTTP_COOKIE_VARS , $HTTP_SESSION_VARS, $PHP_SELF, $REMOTE_ADDR, $HTTP_USER_AGENT, $HTTP_SERVER_VARS ;

	$PIV_PARA= array_merge($HTTP_GET_VARS , $HTTP_POST_VARS);
	$PIV_COOKIES = array_merge($HTTP_COOKIE_VARS , $HTTP_SESSION_VARS);
	

	// and some environment variables..
	if (!isset($_SERVER)) { $_SERVER=$HTTP_SERVER_VARS; }
	$PHP_SELF=$_SERVER['PHP_SELF'];
	$REMOTE_ADDR=$_SERVER['REMOTE_ADDR'];
	$HTTP_USER_AGENT=$_SERVER['HTTP_USER_AGENT'];
	// @$HTTP_SESSION_VARS=$_SESSION;

}

function show_piv_para() {
	global $PIV_PARA, $PIV_COOKIES, $HTTP_SESSION_VARS;

	echo "<pre>para ";
	print_r($PIV_PARA);
	//echo "cookies ";
	//print_r($PIV_COOKIES);
	//echo "session ";
	//print_r($HTTP_SESSION_VARS);
	echo "</pre>";
}

// Check if users browser is ie5 or higher.
function ie5up() {

	$errorlevel= error_reporting(0);

	include_once('extra/phpsniff/phpSniff.class.php');

    $client = new phpSniff($UA,0);
    $client->init();

	error_reporting($errorlevel);

	return $client->is('b:ie5up');
}

function check_php_version($version) {
// intval used for version like "4.0.4pl1"
    $testVer=intval(str_replace(".", "",$version));
    $curVer=intval(str_replace(".", "",phpversion()));
    if( $curVer < $testVer )
      return false;
    return true;
}

// calculate time that was needed for execution
// irt.org rules hardcore!
function timetaken($type="") {
global $starttime;
	$endtime = microtime(); 
	$parts_of_starttime = explode(' ', $starttime); 
	$starttime = $parts_of_starttime[0];
	if (isset($parts_of_starttime[1])) {
		$starttime += $parts_of_starttime[1]; 
	}
	$parts_of_endtime = explode(' ', $endtime); 
	$endtime= $parts_of_endtime[0] + $parts_of_endtime[1]; 
	$time_taken = $endtime - $starttime;
	$time_taken= number_format($time_taken, 2);  // optional

	if ($type=="int") {
		return $time_taken;
	} else {
		return "<span class='timetaken'>$time_taken</span>";
	}
}


// print debug info..
function debug($line) {
global $global_pref;
	if ($global_pref['debug']=="yes") {
		echo "<span class='timetaken'>-".timetaken()."- $line --</span><br>\n";
	}
}

function getextension($file) {
	$pos=strrpos($file, ".");
	if (is_string ($pos) && !$pos) {
	    // not found...
		return "";
	} else {
		$ext=substr($file, $pos+1);
		//echo "ext=$ext<br>\n";
		return $ext;
	}
}


function in_weblog() {
	global $db_temp;

	return (isset($db_temp));
}

// A quick and dirty PHP function to update Weblogs.com
// ----------------------------------------------------
// This was written by Matt Bean, bean@yaysoft.com
// This is a modified version. See www.yaysoft.com for the original.
function pingWeblogs($name="", $url="") {
	global $default_name, $default_url, $global_pref, $HTTP_SERVER_VARS, $db;

	if (!$name) $name = $db->globals['title'];
	if (!$url)  $url  = "http://".$HTTP_SERVER_VARS['HTTP_HOST'].$global_pref['log_url'];	 

	debug("name: $name, url: $url");

	$fp = fsockopen("rpc.weblogs.com", 80, $errnum, $errstr);

	if(!$fp) { 
		echo "$errstr ($errnum)<br>\n";
		$output = "<b>ERROR:</b> Weblogs.com was not notified. (your weblog itself is fine, though!)";
	} else  {
		$len = strlen($name) + strlen($url) + strlen("<?xml version=\"1.0\"?"."><methodCall><methodName>weblogUpdates.ping</methodName><params><param><value></value></param><param><value></value></param></params></methodCall>");
		fputs($fp,"POST /RPC2 HTTP/1.0\r\n");
		fputs($fp,"User-Agent: Bean's Weblogs.com Updater (PHP Stylin')\r\n");
		fputs($fp,"Content-Type: text/xml\r\n");
		fputs($fp,"Content-length: $len\r\n\r\n");
		fputs($fp,"<?xml version=\"1.0\"?"."><methodCall><methodName>weblogUpdates.ping</methodName><params><param><value>$name</value></param><param><value>$url</value></param></params></methodCall>");		 
		$output="";
		while(!feof($fp)) $output.=fgets($fp,4096);
		fclose($fp);		 
	}

	$output = preg_replace("/.*<\/boolean>/si","",$output);
	$output = preg_replace("/.*<value>/si","",$output);
	$output = preg_replace("/<\/value>.*/si","",$output);	 	 
	return $output;
}

function fill_comment_form($name, $email, $url, $cookie, $comm) {
	
	echo "<script>\n";
	if ($name!="") {
		echo "document.form.f_comm_name.value='".addslashes($name)."';\n";
	}
	if ($email!="") {
		echo "document.form.f_comm_email.value='".addslashes($email)."';\n";
	}
	if ($url!="") {
		echo "document.form.f_comm_url.value='".addslashes($url)."';\n";
	}
	if ($comm!="") {
		echo "document.form.f_comm_comment.value='".addslashes($comm)."';\n";
	}

	if ($cookie!="") {
		echo "document.form.cookie.checked=true;\n";
	}
	echo "</script>\n";

}		

function init_emoticons() {
	global $emot, $emot_path,$global_pref;
	//debug("emoticons are go!");

	include ("emoticons.php");
	foreach ($emot as $emot_code => $emot_file) {
		$emot[$emot_code]=sprintf("<img src='%s%s' alt='%s' align='absmiddle'>", $emot_path, $emot_file, addslashes($emot_code));
	}
}

function emoticonize($text) {
	global $emot;
	foreach ($emot as $emot_code => $emot_html) {
		$text=str_replace($emot_code, $emot_html, $text);
		
	}
	return $text;
}

function targetblank($text) {
	global $global_pref;

	if ( ($global_pref['targetblank']) || ($global_pref['targetblank']=="yes") ) {
		$text = preg_replace("'<a href=[\"|\'](.*[^>])[\"|\']([^<>]*)>(.*)</a>'iUs", "<a href=\"\\1\" \\2 target='_blank'>\\3</a>",$text);
	}
	return $text;

}


// show a small menu after a entry has been added of modified
function show_posted_menu($entryfilename, $f_postpone="") {
	global $global_pref, $db;

	if ($global_pref['live_comments']) {
		$entryfilename="entry.php?uid=".$entryfilename;
	}

	echo "<HTML><HEAD><TITLE>Submitted an Entry</TITLE>\n";
	echo "<META http-equiv=Content-Type content=\"text/html; charset=windows-1252\">\n";
	echo "<META http-equiv=Expires content=\"Fri, Jun 12 1981 08:20:00 GMT\">\n";
	echo "<META http-equiv=Pragma content=no-cache>\n";
	echo "<META http-equiv=Cache-Control content=no-cache>\n";
	echo "<STYLE>@import url(extra/pivot.css);</STYLE>\n";
	echo "<BODY bgColor='#FFFFFF' text='#000000' link='#990000' vlink='#990000' alink='#660000' leftmargin=0 topmargin=0>\n";
	include "extra/cmt_inc/nomenu.html";
	echo "<div class='extrapadding'>";
	
	if ($f_postpone!="") {
		echo "<b>Your entry was submitted, but not posted, since it is postponed.</b><br><br>\n";
	} else if (!($global_pref['live_comments'])) {
		if (file_exists($entryfilename)) {
			echo "<b>Your entry was submitted and posted to your log.</b><br><br>\n";
		} else {
			echo "<b>Your entry was not posted correctly.. Check your settings</b><br><br>\n";
		}
	}
	$indexpage=$global_pref['local_path'].$global_pref['index'];
	echo "<ul><li>go to <a href='$indexpage' onclick='document.clientWidth=800;return true;'>your weblog</a><br><br>\n\n";
	echo "<li>go to the <a href='$entryfilename'>new entry</a><br><br>\n\n";	
	echo "<li>close <a href='javascript:self.close();'>this screen</a><br><br>\n\n";

	echo "<li>write <a href='log.php'>another entry</a></ul><br><br>\n\n";



	if ($global_pref['ping_weblogs']==TRUE) {

		echo "<hr size=1>";
		echo "trying to notify weblogs.com:<br>\n";
		flush();
		echo "weblogs.com said: ".rem_entities(pingWeblogs());
	}

	echo "</div>";

	refresh_overview();
}

function refresh_overview() {
	echo "<script>
	if (window.opener) { 
		myopener=window.opener.location;
		if (String(myopener).indexOf('overview')>0) {
			window.opener.location='overview.php';
		}
	}
	</script>";
}

// for the comments we use this function..
// we strip _all_ tags except <b> and <i> and after that
// we convert everything that looks like a url or mail-adress
// to the equivalent link.. very nifty.. 
function comment_format($text) {
global $global_pref;
	
	$text=strip_tags($text,"<b>,<i>,<em>,<strong>");

	$text=xml2html($text);

	if ( (isset($global_pref['comment_wrap'])) && ($global_pref['comment_wrap']>0) && check_php_version('4.0.3') ) {
		$text= wordwrap( $text, $global_pref['comment_wrap'], " ", 1);
	}

	$lines = split("\n",$text);
	$newtext="";

	while ( list ($key,$line) = each ($lines)) {
		if  ( ($global_pref['targetblank']=="yes") || ($global_pref['targetblank']==1) ) {
			$target=" target=\"_blank\"";
		} else {
			$target="";
		}
		
		$line = eregi_replace("([ \t]|^)www\."," http://www.",$line);
		$line = eregi_replace("([ \t]|^)ftp\."," ftp://ftp.",$line);
		$line = eregi_replace("(http://[^ )\r\n]+)","<A href=\"\\1\"$target>[[\\1]]</A>",$line);
		$line = eregi_replace("(https://[^ )\r\n]+)","<A href=\"\\1\"$target>[[\\1]]</A>",$line);
		$line = eregi_replace("(ftp://[^ )\r\n]+)","<A href=\"\\1\"$target>[[\\1]]</A>",$line);
		$line = eregi_replace("([-a-z0-9_]+(\.[_a-z0-9-]+)*@([a-z0-9-]+(\.[a-z0-9-]+)+))","<A HREF=\"mailto:\\1\">\\1</A>",$line);

		// then make long urls into short urls, with correct link..
		preg_match_all ("|\[\[(.*)\]\]|U", $line, $match, PREG_PATTERN_ORDER);

		foreach($match[1] as $url) {
			if (strlen($url)>40) { 
				$short_url=substr($url,0,40)."..";
			} else {
				$short_url=$url;
			}

			$line=str_replace("[[".$url."]]", $short_url, $line);
		}

		$newtext .= $line . "<br>\n";
	} 

	if ($global_pref['emoticons']=="yes") {
		$newtext=emoticonize($newtext);
	}

	if ($global_pref['targetblank']=="yes") {
		$newtext=targetblank($newtext);
	}

	return $newtext;
	
}

// give this function a string and it will tell you
// whether it is a mail adress or not.. magically!!
function isemail($email) {
	if (eregi("([-a-z0-9_]+(\.[_a-z0-9-]+)*@([a-z0-9-]+(\.[a-z0-9-]+)+))", $email)) {
		return true;
	} else {
		return false;
	}
}


// give this function a string and it will tell you
// whether it is a url or not.. magically!!
function isurl($url) {
	$url = eregi_replace("([ \t]|^)www\."," http://www.",$url);
	if (eregi("(http://[^ )\r\n]+)", $url)) {
		return true;
	} else {
		return false;
	}
}

function safestring($name) {
	return ereg_replace("[^-a-zA-Z0-9_.]", "", $name);
}

function encodemail($mail) {
	global $global_pref;

	if ($global_pref['encode_email_addresses']) {
		include_once "extra/safeaddress.inc.php";
		$mail = safeAddressPlain($mail, 0, 0);
		return $mail;
	} else {
		return $mail;
	}

}

function encodemail_link($mail, $nick, $title="") {
	global $global_pref;

	if ($mail=="") {
		return $nick;
	} else {
		$mail=strip_tags($mail);
	}

	if ($title=="") {
		$title=$nick;
	} else {
		$title=strip_tags($title);
	} 

	if ($global_pref['encode_email_addresses']) {
		include_once "extra/safeaddress.inc.php";
		$mail = safeAddress($mail, $nick, "email $title", 0, 0);
		return $mail;
	} else {
		return "<a href='mailto:$mail' title='email $title'>$nick</a>";
	}

}



function is_word_html($text) {
	
	$a = strpos($text, "<o:p></o:p>");
	$b = strpos($text, "MsoNormal");
	$c = strpos($text, "mso-bidi");
	$d = strpos($text, "xml:namespace");
	
	return ($a || $b || $c || $d);
}

function strip_word_html($text) {
	
//	echo "\n\n\n\n<hr>$text<hr>";

	$text = stripslashes($text);
	$text = str_replace("<?xml:namespace", "<pom", $text); 
	$text = strip_tags($text,'<b><i><u><a><br>');
	$text = eregi_replace ("<a[^>]+href *= *([^ ]+)[^>]*>", "<a href=\\1>", $text);
	$text = eregi_replace ("<([b|i|u|br])[^>]*>","<\\1>", $text);

	return $text;
}


// adapted from an article by Allan Kent on phpbuilder.com
// this function takes the current system time and dat, and offsets
// it to get the time and date we want to output to our users.
function get_current_date() {
global $global_pref;

	$date_time_array  = getdate();

	$hours =  $date_time_array["hours"];
	$minutes =  $date_time_array["minutes"];
	$seconds =  $date_time_array["seconds"];
	$month =  $date_time_array["mon"];
	$day =  $date_time_array["mday"];
	$year =  $date_time_array["year"];
	
	$timestamp =  mktime($hours ,$minutes, $seconds,$month ,$day, $year);
	
    switch ($global_pref['timeoffset_unit']) {
    
        case "y": $year +=$global_pref['timeoffset']; break;        
        case "m": $month +=$global_pref['timeoffset']; break;        
        case "d": $day+=$global_pref['timeoffset']; break;        
        case "h": $hours+=$global_pref['timeoffset']; break;        
        case "i": $minutes+=$global_pref['timeoffset']; break;        

    }    
	$timestamp =  mktime($hours ,$minutes, $seconds,$month ,$day, $year);
    return $timestamp;

}

// gives the correct filename for a given code
// example: 'blog-1' returns '../entry_blog-1.html';
function code2filename ($code) {
	global $global_pref;
	
	$path=$global_pref['local_path'];
	$file=$global_pref['file_format'];
	$file=str_replace("%1", rem_code_padding($code), $path.$file);
	return $file;
}

function code2url ($code) {
	global $global_pref, $HTTP_SERVER_VARS;
	
	$host="http://".$HTTP_SERVER_VARS['HTTP_HOST'];
	$path=$global_pref['log_url'];
	$file=$global_pref['file_format'];
	$file=str_replace("%1", rem_code_padding($code), $host.$path.$file);
	return $file;
}

function get_archive_name($date) {
	global $global_pref;

	$year = format_date($date, "%year%");

	$archive_num= ($global_pref['archive_unit']=="week") ? format_date($date, "%weeknum%") : format_date($date, "%month%");
	$archive_type= ($global_pref['archive_unit']=="week") ? "w" : "m";
	$archive_name=sprintf("%s-%s%s", $year, $archive_type, $archive_num);
	$archive_name=str_replace("%1",$archive_name,$global_pref['archive_format']);

	// debug("arc_name: $archive_name ($date)");

	return $archive_name;
}

function get_archive_num($date) {
	global $global_pref;

	$year = format_date($date, "%year%");

	$archive_num= ($global_pref['archive_unit']=="week") ? format_date($date, "%weeknum%") : format_date($date, "%month%");
	$archive_type= ($global_pref['archive_unit']=="week") ? "w" : "m";
	$archive_num=sprintf("%s-%s%s", $year, $archive_type, $archive_num);
	

	// debug("arc_name: $archive_name ($date)");

	return $archive_num;
}

/*
function get_comment_names(&$commcount, &$commnames) {
	global $db_temp, $global_pref;

	if ( (isset($db_temp->entry['comments'])) && (count($db_temp->entry['comments'])>0) && ($db_temp->entry['comments']!=0) ) {
						
		$cnames_arr=Array();
		foreach ($db_temp->entry['comments'] as $comment) {
			$cnames_arr[]=$comment['name'];
		}
		$commnames=implode(", ",array_unique ($cnames_arr));
		$commcount=count($cnames_arr);
	} else {
		$commcount=0;
		$commnames="";
	}

	if ($commcount==0) { 
		$commcount=$global_pref['commentsarr'][0];
		$commcount=str_replace("%num%", $global_pref['comments_numbersarr'][0], $commcount);
	} else if ($commcount==1) { 
		$commcount=$global_pref['commentsarr'][1]; 
		$commcount=str_replace("%num%", $global_pref['comments_numbersarr'][1], $commcount);
	} else {
		if (isset($global_pref['comments_numbersarr'][$commcount])) {
			$num=$global_pref['comments_numbersarr'][$commcount];
		} else {
			$num=$commcount;
		}

		$commcount=$global_pref['commentsarr'][2]; 
		$commcount=str_replace("%num%", $num, $commcount);
	}
	debug("commcount van: ".$db_temp->entry['id']." = ".$commcount);

}
*/

//format a date for pretty printing
function format_date( $date, $format) {
	global $global_pref, $current_date;
	
	if ($format=="") { $format=$global_pref['entrydate_format']; }
	if ($date=="") {$date= $current_date; }
	list($yr,$mo,$da,$ho,$mi)=split("-",$date);
	$mo_name=$global_pref['months'][-1+$mo];
	$da_name=$global_pref['weekdays'][date("w",mktime(0,0,0,$mo,$da,$yr))];
	$wk_num=floor(date("z",mktime(0,0,0,$mo,$da,$yr)) / 7)+1;
	$ye=substr($yr,2);
	$ho12=$ho;
	if ($ho12>11) { $ho12=$ho12-12; }
	$ampm= ($ho12==$ho) ? "am" : "pm";
	if ($ho12==0) { $ho12=12; }

	
	$format=str_replace("%minute%", $mi, $format);
	$format=str_replace("%hour12%", $ho12, $format);
	$format=str_replace("%ampm%", $ampm, $format);
	$format=str_replace("%hour24%", $ho, $format);
	$format=str_replace("%day%", $da, $format);
	$format=str_replace("%weekday%", $da_name, $format);
	$format=str_replace("%weeknum%", $wk_num, $format);
	$format=str_replace("%month%", $mo, $format);
	$format=str_replace("%monthname%", $mo_name, $format);
	$format=str_replace("%monname%", $mo_name, $format);
	$format=str_replace("%year%", $yr, $format);
	$format=str_replace("%ye%", $ye, $format);

	return $format;
}


// function add_code_padding
// eg. 'blog-2' returns 'blog-0002'
function add_code_padding($code) {

	$code_arr=split("-",$code);
	if (strpos($code,">")>0) {	// code is something like 'news>' ?
						// if it is, find the current highest value, and add 1.
		$code=substr($code, 0, strpos($code,">"));
		$max=0;
		$max=find_max_sub($code);
		$code=sprintf("%s-%04d",$code, $max+1);
		return $code;
	}

	for ($i=0;$i<count($code_arr);$i++) {
		if (ereg("[0-9]+", $code_arr[$i])) { // is it a number?
			$code_arr[$i]=sprintf("%04d",$code_arr[$i]);
		}
	}
	$code=implode("-",$code_arr);
	return $code;
}


// function to remove code-padding.
// eg. '0001-0123-0010' returns '1-123-10'
function rem_code_padding($code) {
	$code_arr=split("-",$code);
	for ($i=0;$i<count($code_arr);$i++) {
		if (ereg("[0-9]+", $code_arr[$i])) { // is it a number?
			$code_arr[$i]=0+$code_arr[$i];
		}
	}
	$code=implode("-",$code_arr);
	return $code;
}


// Add a line to the log file.
function add_log($entry, $usernm="") {
	global $log_date, $global_pref, $user, $REMOTE_ADDR;

	if ($usernm=="") { $usernm=$user['name']; }

	if ($global_pref['log_access']) {
		if($fp=fopen("db/logfile.txt.php", "a-")) {
			fwrite($fp, "[$log_date / ip:".$REMOTE_ADDR."] - $usernm - $entry\n");
			fclose($fp);
		}
	}
}


// find the parent of a given code.
// example: '3-2-4' returns '3-2'
function find_parent($code) {
	$code=rem_code_padding($code);
	$pos=strrpos($code, "-");
	if ($pos>0) {
		$code=substr($code, 0, $pos+1);
		if ($code[strlen($code)-1]=="-") {
			$code=substr($code,0,strlen($code)-1);
		}
	} else {
		$code="";
	}
	return $code;
}


// get_attr_value
//
// This function will search $attributes for the value for the
// the attribute in $att_name.
// for example, after calling:
// $my_value=get_attr_value('size', 'color="green" size="12"');
// my_value will contain 12
function get_attr_value($att_name, $attributes) {
	// first, we need do do some tricks to find out where we'll have
	// to split the $attributes string
	
	$attributes=stripslashes(str_replace("&quot;",'"', $attributes));
	$this_attr=substr($attributes, strpos($attributes,$att_name));
	$pos=strpos($attributes,$att_name);

	if (preg_match("/$att_name=\"([^\"]*)\"/i", $attributes, $parts)) {
		return $parts[1];
	} else {
		return "";
	}
}

// removes all chars from a given string that might cause
// problems when written in an XML file..
function strip_badchars($str) {

	// strip everything we don't like..
	for ($i=0; $i<strlen($str); $i++) {
		$ord = ord($str[$i]); 
//		if ( ($ord<9) || ( ($ord>13) && ($ord<32) ) || ($ord>126) ) {
		if ( ( ($ord!=9) && ($ord!=10) && ($ord!=13) ) && ( ($ord<32)  || ($ord>126) ) ) {
			//echo("Zap! ".$str[$i]." = ".$ord."<br>\n ");
			$str[$i]=" ";
		} //else { echo $str[$i]." = ".$ord."<br>\n "; }
	}
	return $str;

}

function count_level($code) {
	$count=ereg_replace("[^-]", "", $code);
	$count=strlen($count)+1;
	return $count;

}


function strip_trailing_space($text) {
	global $global_pref;

	if (!($global_pref['allow_paragraphs'])) {
		$text=preg_replace("~<p>~mi","", $text);
		$text=preg_replace("~</p>~mi","<br><Br>", $text);
		//debug('strip');
	} else {
		//debug('niet strip');
	}

	$text=trim($text)."[[end]]";
	$end_p = preg_match("~</P>\[\[end\]\]$~mi", $text);
	// $text = preg_replace("~(&nbsp;|<br>|<br>|<P>|</P>|\n|\r| )*\[\[end\]\]$~mi", "\\2", $text);
	$text = preg_replace("~(&nbsp;|<br>|<br>|<P>|</P>|\n|\r| )*\[\[end\]\]$~mi", "", $text);
	if ($end_p) { $text.="</P>"; }
	
	return $text;
}


function html_entities($str, $strip=0) {
global $encode_html;

	// make as much entities as we can..
	$out = strtr(strtr ($str, $encode_html), $encode_html);

	$out = str_replace("#039;", "amp;", $out);

	// for comments we just kick out everything that doesn't look like
	// a valid character.
	if ($strip==1) {
		// strip everything we don't like..
		$out=strip_badchars($out);
	}
	return $out;

}	

function rem_entities($str) {
global $decode_html;
$str = str_replace ('&amp;', "&", $str);
return strtr ($str, $decode_html);

}

function xml2html($i) {

	$i=htmlentities(stripslashes($i));
	
	// according to the php manual, these have to be translated back
	// in order to output proper html
	// '&' (ampersand) becomes '&amp;' 
	// '"' (double quote) becomes '&quot;' when ENT_NOQUOTES is not set. 
	// ''' (single quote) becomes '&#039;' only when ENT_QUOTES is set. 
	// '<' (less than) becomes '&lt;' 
	// '>' (greater than) becomes '&gt;' 

	$i = str_replace ('&lt;', '<', $i);
	$i = str_replace ('&gt;', '>', $i);
	$i = str_replace ('&quot;', '"', $i);
	$i = str_replace ('&#039;', "'", $i);
	$i = str_replace ('&amp;', "&", $i);
	
	return $i;
	
}


function txt2form($i) {

	$i = stripslashes( $i );
	$i = str_replace ('"', '&quot;', $i);
	$i = str_replace ("'", '&#039;', $i);
	return $i;


}

//function html2xml($str) {
//global $encode_html;
//	$str=strtr ($str, $encode_html);
//	return addslashes($str);
//}


//these are deprecated.. don't use anymore..

function asc2html($i) {
	$i = htmlentities($i);
	$i = addslashes($i);
	return $i;
}

function html2asc($i) {
	$i = stripslashes($i);
	//$i = strtr($i, $decode_html);
	$i= str_replace("&#039;","&",$i);
	$i= str_replace("#039","amp",$i);
	return $i;
}


function escape($i) {
global $decode_html;
	$i = stripslashes($i);
	//$i = strtr($i, $decode_html);

	// according to the php manual, these have to be translated back
	// in order to output proper html
	// '&' (ampersand) becomes '&amp;' 
	// '"' (double quote) becomes '&quot;' when ENT_NOQUOTES is not set. 
	// ''' (single quote) becomes '&#039;' only when ENT_QUOTES is set. 
	// '<' (less than) becomes '&lt;' 
	// '>' (greater than) becomes '&gt;' 

	$i = str_replace ('&lt;', '<', $i);
	$i = str_replace ('&gt;', '>', $i);
	$i = str_replace ('&quot;', '"', $i);
	$i = str_replace ('&#039;', "'", $i);
	$i = str_replace ('&amp;', "&", $i);
	
	return $i;
}

function xformat_html($i) {
	$i=html2asc($i);

	$i=nl2br($i);
	return $i;
}

function xformat_xml($i) {
	$i=strip_tags($i);
	$i=htmlentities($i);
	return $i;
}



// =============================================
// the functions below are used for outputting 
// the weblog as RSS.
// =============================================

function rss_offset() {

	return sprintf("%02d:%02d", floor(date("Z")/3600), floor(date("Z") % 3600));

}

function start_rss() {
	global $rss, $db,$global_pref, $HTTP_SERVER_VARS, $version, $user;

	$link = "http://".$HTTP_SERVER_VARS['HTTP_HOST'].$global_pref['log_url'];

	if (!isset($rss)) {

		$preamble='<?xml version="1.0" encoding="ISO-8859-1"?>
<rss version="2.0" 
    xmlns:dc="http://purl.org/dc/elements/1.1/"
    xmlns:sy="http://purl.org/rss/1.0/modules/syndication/"
    xmlns:admin="http://webns.net/mvcb/"
    xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
    xmlns:content="http://purl.org/rss/1.0/modules/content/">

  <channel>
    <title>%title%</title>
    <link>%link%</link>
    <description>%description%</description>
    <dc:language>en-us</dc:language>
    <dc:creator>%author%</dc:creator>
    <dc:rights>Copyright %year%</dc:rights>
    <dc:date>%date%</dc:date>
    <admin:generatorAgent rdf:resource="%genagent%" />
    <admin:errorReportsTo rdf:resource="mailto:rsserrors@mijnkopthee.nl"/>
    <sy:updatePeriod>hourly</sy:updatePeriod>
    <sy:updateFrequency>1</sy:updateFrequency>
    <sy:updateBase>2000-01-01T12:00+00:00</sy:updateBase>';

	$preamble= str_replace("%title%", $db->globals['title'], $preamble);
	$preamble= str_replace("%link%", $link, $preamble);
	$preamble= str_replace("%description%", $db->globals['subtitle'], $preamble);
	$preamble= str_replace("%author%", $user['name'], $preamble);
	$preamble= str_replace("%year%", date("Y"), $preamble);
	$preamble= str_replace("%date%", date("Y-m-d\TH:i:s+").rss_offset(), $preamble);
	$preamble= str_replace("%genagent%", "http://www.mijnkopthee.nl/pivot/?v=".$version, $preamble);
	//$preamble= str_replace("%%", $db->globals['subtitle'], $preamble);
	//$preamble= str_replace("%%", $db->globals['subtitle'], $preamble);


		$rss = $preamble;
	}
}

function add_rss() {
	global $rss, $global_pref, $db_temp, $HTTP_SERVER_VARS;

	$link=$db_temp->set_url();
	$weblog="http://".$HTTP_SERVER_VARS['HTTP_HOST'].$global_pref['log_url'];

	$introduction=parse_step4($db_temp->entry['introduction']);
	$body=parse_step4($db_temp->entry['body']);

	$description=strip_tags($introduction);

	if ( (isset($global_pref['rss_entry_length'])) && (strlen($description)>$global_pref['rss_entry_length']) ) {
		$description=htmlspecialchars(substr($description, 0, $global_pref['rss_entry_length'])."..");
		$description=str_replace("&nbsp;"," ", $description);
	}

	$item='
	<item>
      <title>%title%</title>
      <link>%link%</link>
      <description>%description%</description>
      <guid isPermaLink="false">%guid%</guid>
      <content:encoded><![CDATA[%content%]]></content:encoded>
      <dc:subject>%category%</dc:subject>
      <dc:date>%date%</dc:date>
    </item>';

	$item= str_replace("%title%", htmlspecialchars(strip_tags($db_temp->entry['title'])), $item);
	$item= str_replace("%link%", $link, $item);
	$item= str_replace("%description%", htmlspecialchars($description), $item);
	$item= str_replace("%author%", $db_temp->entry['user'], $item);
	$item= str_replace("%guid%", $db_temp->entry['id']."@".$weblog, $item);
	$item= str_replace("%date%", format_date( $db_temp->entry['date'], "%year%-%month%-%day%T%hour24%:%minute%:00+").rss_offset(), $item);
	$item= str_replace("%category%", $db_temp->entry['category'], $item);
	$item= str_replace("%content%", nl2br($introduction.$body), $item);


	$rss.=$item;
	//debug ("add RSS: $link");

	

}

function finish_rss() {
	global $rss, $global_pref;

	if (isset($rss)) {

		$rss.="\n</channel>\n</rss>";


		$fp=fopen("../".$global_pref['rss'],"w");
		fwrite($fp, $rss);
		fclose ($fp);
		debug("klaar!");
	}


}

// =============================================
// the functions below are used for processing the <cms> tags
// into <html>.
// =============================================

function cms_tag_title($tag_attr, $tag_default) {
	global $db;
	if ($db->entry['title']) {
		$output=sprintf("%s",$db->entry["title"]); 
	} else {
		$output="$tag_default";
	}
	return $output;
}

function cms_tag_subtitle($tag_attr, $tag_default){
	global $db;
	if ($db->entry["subtitle"]) {
		$output=sprintf("%s",$db->entry["subtitle"]); 
	} else {
		$output="$tag_default";
	}
	return $output;

}

function cms_tag_introduction($tag_attr, $tag_default){
	global $db, $global_pref;

	if ($db->entry["introduction"]) {
		// oud = $output=sprintf("%s",format_html($row["introduction"])); 
		$introduction=str_replace("&lt;", "<", $db->entry["introduction"]);
		$output=$introduction;
	} else {
		$output="$tag_default";
	}

	$output=targetblank($output);

	if ($global_pref['emoticons']=="yes") {
		$output=emoticonize($output);
	}

	return $output;
}

function cms_tag_body($tag_attr, $tag_default){
	global $db, $global_pref;

	if ($db->entry["body"]) {
		//oud = $output=sprintf("%s",format_html($row["body"])); 
		$output='<a name="body"></a>'.$db->entry["body"]; 
	} else {
		$output="$tag_default";
	}

	$output=targetblank($output);

	if ($global_pref['emoticons']=="yes") {
		$output=emoticonize($output);
	}

	return $output;
}

function cms_tag_code($tag_attr, $tag_default){
	global $db;

	if ($db->entry["code"]) {
		$output=sprintf("%s",rem_code_padding($db->entry["code"])); 
	} else {
		$output="$tag_default";
	}
	return $output;
}

function cms_tag_user($tag_attr, $tag_default){
	global $db;

	if ($db->entry["user"]) {
		$output=sprintf("%s",$db->entry["user"]); 
	} else {
		$output="$tag_default";
	}
	return $output;

}

function cms_tag_nick($tag_attr, $tag_default){
global $db, $nick, $global_user;

	if ($db->entry["user"]) {
		$output=sprintf("%s",$global_user[$db->entry["user"]]['nickname']); 
	} else {
		$output="$tag_default";
	}
	return $output;
}

function cms_tag_email($tag_attr, $tag_default){
global $db, $email, $global_user;

	if ($db->entry["user"]) {
		$output=sprintf("%s",encodemail($global_user[$db["user"]]['email'])); 
	} else {
		$output="$tag_default";
	}
	return $output;

}

function cms_tag_emailtonick($tag_attr, $tag_default){
global $db, $email, $global_user;

	if ($db->entry["user"]) {
		$output=sprintf("%s",$global_user[$db["user"]]['email']); 
	} else {
		$output="$tag_default";
	}
	return $output;

}

/*
function cms_tag_link($tag_attr, $tag_default){
global $db;

	if ($row["title"]) {
		$href=get_attr_value('href', $tag_attr);
		$output="<a href='preview.php?code=$href'>$tag_default</a>"; 
	} else {
		$output="TAG LINK: $tag_default";
	}
	return $output;

}
*/

function cms_tag_date($tag_attr, $tag_default){
	global $db, $global_pref;

	$format=get_attr_value('format', $tag_attr);

	if ($format=="") { $format=$global_pref['fulldate_format']; }

	if ($db->entry["date"]) {
		$output=format_date($db->entry['date'],$format); 
	} else {
		$output=$tag_default;
	}
	return $output;

}


function cms_tag_media($tag_attr, $tag_default){
global $db;

	$file=get_attr_value('file', $tag_attr);
	$type=get_attr_value('type', $tag_attr);

	//echo "attr = $tag_attr<br><br>\n";
	//echo "file = $file<br><br>\n";
	//echo "type = $type<br><br>\n";

	if ($type=="popup") {
		$output=sprintf("<a href=\"%s\">%s</a>",$file, $type);
		//$output="popopopup: $file, $type";
		//echo $output;
	}
	
	return $output;

}


function cms_tag_archivelink($tag_attr, $tag_default){
global $db, $archive_index, $archive_count, $global_pref;

	$type=get_attr_value('type', $tag_attr);
	$format=$global_pref['archive_link'];

	$output="";

	if ($type=="previous") {
		if (isset($archive_index[$archive_count-1])) {
			$number=$archive_index[$archive_count-1]['num'];
			$name=$archive_index[$archive_count-1]['name'];
			$file=str_replace("%1",$name,$global_pref['archive_format']);
			$output=str_replace("%name%", $name, $format);
			$output=str_replace("%url%", $file, $output);
		}
	}
	
	if ($type=="current") {
		$number=$archive_index[$archive_count]['num'];
		$name=$archive_index[$archive_count]['name'];
		$file=str_replace("%1",$name,$global_pref['archive_format']);
		$output=str_replace("%name%", $name, $format);
		$output=str_replace("%url%", $file, $output);
	}
	
	if ($type=="next") {
		if (isset($archive_index[$archive_count+1])) {
			$number=$archive_index[$archive_count+1]['num'];
			$name=$archive_index[$archive_count+1]['name'];
			$file=str_replace("%1",$name,$global_pref['archive_format']);
			$output=str_replace("%name%", $name, $format);
			$output=str_replace("%url%", $file, $output);
		}
	}
	
	return $output;

}

function cms_tag_include($tag_attr, $tag_default){

	$file=get_attr_value('file',$tag_attr);
	
	if (!(file_exists($file))) { $file="../".$file; }
	
	if (file_exists($file)) {
		$filepointer=fopen($file,"r");
		$filetext=fread ($filepointer, filesize ($file));
		fclose ($filepointer);
		$output=$filetext;		
	} else {	
	$output="<!-- failed to include '$file' -->\n";
	}
	return $output;

}



function cms_tag_archive($tag_attr, $tag_default){
	global $index, $index_count, $arc_value, $db, $db_temp, $diffdate_lastformat, $global_user, $global_pref, $current_date;


	$entrydate=$global_pref['entrydate_format'];
	$diffdate=$global_pref['diffdate_format'];

	$countshow=0;
	$output="";

	$db->entry['filename']='ROOT';

	if (!isset($db_temp)) {
		$db_temp = new db_xml('standard',TRUE);
	}

	$res=$db_temp->setpointer("last");

	$category=get_attr_value('category', $tag_attr);

	debug("archive <b>$category</b>");

	if (isset($db->globals[$category]['shortentry'])) {
		$tag_default_orig= implode("", file("templates/".$db->globals[$category]['shortentry']));
	} else {
		$tag_default_orig= implode("", file("templates/".$db->globals['shortentry']));
	}

	if (!isset($db_temp)) {
		$db_temp = new db_xml('standard',TRUE);
	}
	//$res=$db_temp->setpointer("last");
	//$numentries=$db_temp->get_entries_count();

	if ( (isset($global_pref['archive_order'])) && ($global_pref['archive_order']=="chronological") ) {
		$arc_value= array_reverse($arc_value);
		debug ("andersom");
	} else {
		debug ("niet andersom");
	}

	for ($i=0;$i<count($arc_value);$i++) {

		$entry=$arc_value[$i];

		$file=$db_temp->set_filename($entry);

		$db_temp->setpointer('to', $entry);
		$db_temp->set_id();
		//$db_temp->read_entry($file,FALSE);

		if ( ($current_date>=$db_temp->entry['date']) && ( ($category=="") || ($db_temp->entry['category']==$category) ) ) {
			
			$db_temp->read_entry($file,FALSE);
			
			$tag_default=parse_step4($tag_default_orig);

			$anchor="<a name='".$db_temp->entry['id']."'></a>";

			$diffdate_thisformat=format_date($db_temp->entry["date"],$diffdate).
				"<a name='".format_date($db_temp->entry["date"],"%year%%month%%day%")."'></a>";
			if ($diffdate_lastformat!=$diffdate_thisformat) {
				$diffdate_lastformat=$diffdate_thisformat;
			} else {
				$diffdate_thisformat="";
			}


			$commcount=$db_temp->entry['commcount'];
			$commnames=$db_temp->entry['commnames'];

			$file=$global_pref['log_url'].str_replace("%1", rem_code_padding($db_temp->entry["code"]), $global_pref['file_format']);
			$file=str_replace("//", "/", $file);

			$permalink=get_archive_name($db_temp->entry['date'])."#".$db_temp->entry['id'];

			if (strlen($db_temp->entry['body'])>5) {
				if ($global_pref['live_comments']) {
					$morelink=$global_pref['pivot_url']."entry.php?uid=".$db_temp->entry['id']."#body";
				} else {
					$morelink=$db->make_filename($db_temp->entry['id'])."#body";
				}
				//debug("morelink: ".$morelink);
				$readmore="<a href=\"$morelink\">".$global_pref['readmore']."</a>";	
			} else {
				$readmore="";
			}

			

			// old users must be changed to 'nobody'..
			if (!isset($global_user[$db_temp->entry["user"]])) {
				$global_user[$db_temp->entry["user"]]=$global_user['nobody'];
			}

			// emoticons..
			if ( (isset($global_pref['emoticons'])) && ($global_pref['emoticons']=="yes") ) {
				$db_temp->entry["introduction"]=emoticonize($db_temp->entry["introduction"]);
				$db_temp->entry["body"]=emoticonize($db_temp->entry["body"]);
			}

			// targetblank
			if ($global_pref['targetblank']=="yes") {
				$db_temp->entry["introduction"]=targetblank($db_temp->entry["introduction"]);
				$db_temp->entry["body"]=targetblank($db_temp->entry["body"]);
			}

			// commlink
			if ($global_pref['live_comments']) {
				$commlink= $global_pref['pivot_url']."entry.php?uid=".$db_temp->entry['id']."#comm";
			} else {
				$commlink= $file."#comm";
			}

			$this_tag= $anchor.$tag_default;
			$this_tag= str_replace("%title%", $db_temp->entry["title"], $this_tag);
			$this_tag= str_replace("%subtitle%", $db_temp->entry["subtitle"], $this_tag);
			$this_tag= str_replace("%code%", rem_code_padding($db_temp->entry["code"]), $this_tag);
			$this_tag= str_replace("%body%", $db_temp->entry["body"], $this_tag);
			$this_tag= str_replace("%introduction%", "<mode=br><mode=escaped>".parse_step4($db_temp->entry["introduction"])."<mode=nobr><mode=literal>", $this_tag);
			$this_tag= str_replace("%xml-introduction%", xml2html($db_temp->entry["introduction"]), $this_tag);
			$this_tag= str_replace("%user%", $db_temp->entry["user"], $this_tag);
			$this_tag= str_replace("%category%", $db_temp->entry["category"], $this_tag);
			$this_tag= str_replace("%diffdate%", $diffdate_thisformat, $this_tag);
			$this_tag= str_replace("%more%", $readmore, $this_tag);
			$this_tag= str_replace("%date%", format_date($db_temp->entry["date"],$entrydate), $this_tag);
			$this_tag= str_replace("%nick%", $global_user[$db_temp->entry['user']]['nickname'], $this_tag);
			$this_tag= str_replace("%email%", encodemail($global_user[$db_temp->entry['user']]['email']), $this_tag);
			$this_tag= str_replace("%emailtonick%", encodemail_link($global_user[$db_temp->entry['user']]['email'], $global_user[$db_temp->entry['user']]['nickname']), $this_tag);

			// These will be deprecated, and moved to their respective snippets..
			$this_tag= str_replace("%commlink%", $commlink, $this_tag);
			$this_tag= str_replace("%link%", $permalink, $this_tag); // deprecated
			$this_tag= str_replace("%permalink%", $permalink, $this_tag);
			$this_tag= str_replace("%commcount%", "xxx: ".$commcount, $this_tag);
			$this_tag= str_replace("%commnames%", $commnames, $this_tag);

			if (strpos($this_tag, "%introduction-strip%")>0) {
				//debug("%introduction-strip%");
				$stripped=strip_tags($db_temp->entry["introduction"],"<a><b><i><u><embed><strong><ol><li><ul>");
				$stripped="<mode=br><mode=escaped>".$stripped."<mode=nobr><mode=literal>";
				$this_tag= str_replace("%introduction-strip%", $stripped, $this_tag);
			}							

			$output.=$this_tag;
			
		}

	}

	return $output;

}



function cms_tag_weblog($tag_attr, $tag_default){
	global $index, $index_count, $entry, $db, $db_temp, $global_user, $global_pref, $current_date;

	$parent_code=add_code_padding($db->entry["code"]);
	$parent_title=$db->entry["title"];

	$nodes=get_attr_value('nodes', $tag_attr);
	if ($nodes=="equal") {
		$parent_code=find_parent($parent_code);
	}

	$show=get_attr_value('showme', $tag_attr);
	if($show=="") { $show=$db->globals['entries_on_frontpage']; }

	$category=get_attr_value('category', $tag_attr);

	$startat=get_attr_value('startat', $tag_attr);
	if ($startat!="") { $parent_code=$startat; }
	
	$order=get_attr_value('order', $tag_attr);
	if ($order=="firsttolast") { $order="asc"; }
	else { $order="desc"; }
	
	$entrydate=$global_pref['entrydate_format'];
	$diffdate=$global_pref['diffdate_format'];

	$countshow=0;
	$output="";

	//$org_row=$row;

	if (isset($db->globals[$category]['shortentry'])) {
		//debug("cat-temp: ".$db->globals[$category]['shortentry']);
		$tag_default_orig= implode("", file("templates/".$db->globals[$category]['shortentry']));
	} else {
		//debug("begin def-temp: ".$db->globals['shortentry']);
		$tag_default_orig= implode("", file("templates/".$db->globals['shortentry']));
		//debug("einde def-temp: ".$db->globals['shortentry']);
	}


	if  ( (isset($global_pref['rss'])) && ($global_pref['rss']!="") ) { start_rss(); }

	if (!isset($db_temp)) {	
		$db_temp = new db_xml('standard',TRUE);
	}
	$res=$db_temp->setpointer("last");
	$numentries=$db_temp->get_entries_count();

	debug(" *$category*  - $current_date");

	for ($i=0;$i<$numentries;$i++) {

		debug("title: ".$db_temp->entry['title']." - ".$db_temp->entry['date']." - ".$db_temp->entry['category']);

		if ( ($current_date>=$db_temp->entry['date']) && ( ($category=="") || ($db_temp->entry['category']==$category) ) ) {
			
			debug("do");

			$db_temp->read_entry("",FALSE);


			$tag_default=parse_step4($tag_default_orig);

			$diffdate_thisformat=format_date($db_temp->entry["date"],$diffdate);
			if ( (!isset($diffdate_lastformat)) || ($diffdate_lastformat!=$diffdate_thisformat) ) {
				$diffdate_lastformat=$diffdate_thisformat;
				
			} else {
				$diffdate_thisformat="";
			}

			$commcount=$db_temp->entry['commcount'];
			$commnames=$db_temp->entry['commnames'];

			$file=$global_pref['log_url'].str_replace("%1", rem_code_padding($db_temp->entry["code"]), $global_pref['file_format']);
			$file=str_replace("//", "/", $file);

			$permalink=get_archive_name($db_temp->entry['date'])."#".$db_temp->entry['id'];
	
			if (strlen($db_temp->entry['body'])>5) {
				if ($global_pref['live_comments']) {
					$morelink=$global_pref['pivot_url']."entry.php?uid=".$db_temp->entry['id']."#body";
				} else {
					$morelink=$db->make_filename($db_temp->entry['id'])."#body";
				}
				//debug("morelink: ".$morelink);
				$readmore="<a href=\"$morelink\">".$global_pref['readmore']."</a>";	
			} else {
				$readmore="";
			}

			// old users must be changed to 'nobody'..
			if (!isset($global_user[$db_temp->entry["user"]])) {
				$global_user[$db_temp->entry["user"]]=$global_user['nobody'];
			}

			// emoticons..
			if ( (isset($global_pref['emoticons'])) && ($global_pref['emoticons']=="yes") ) {
				$db_temp->entry["introduction"]=emoticonize($db_temp->entry["introduction"]);
				$db_temp->entry["body"]=emoticonize($db_temp->entry["body"]);
			}

			// targetblank
			if ($global_pref['targetblank']=="yes") {
				$db_temp->entry["introduction"]=targetblank($db_temp->entry["introduction"]);
				$db_temp->entry["body"]=targetblank($db_temp->entry["body"]);
			}

			// commlink
			if ($global_pref['live_comments']) {
				$commlink= $global_pref['pivot_url']."entry.php?uid=".$db_temp->entry['id']."#comm";
			} else {
				$commlink= $file."#comm";
			}



			$this_tag= $tag_default;
			$this_tag= str_replace("%title%", $db_temp->entry["title"], $this_tag);
			$this_tag= str_replace("%subtitle%", $db_temp->entry["subtitle"], $this_tag);
			$this_tag= str_replace("%code%", rem_code_padding($db_temp->entry["code"]), $this_tag);
			$this_tag= str_replace("%body%", $db_temp->entry["body"], $this_tag);
			$this_tag= str_replace("%introduction%", "<mode=br><mode=escaped>".parse_step4($db_temp->entry["introduction"])."<mode=nobr><mode=literal>", $this_tag);
			$this_tag= str_replace("%xml-introduction%", xml2html($db_temp->entry["introduction"]), $this_tag);
			$this_tag= str_replace("%user%", $db_temp->entry["user"], $this_tag);
			$this_tag= str_replace("%category%", $db_temp->entry["category"], $this_tag);
			$this_tag= str_replace("%diffdate%", $diffdate_thisformat, $this_tag);
			$this_tag= str_replace("%more%", $readmore, $this_tag);
			$this_tag= str_replace("%date%", format_date($db_temp->entry["date"],$entrydate), $this_tag);
			$this_tag= str_replace("%nick%", $global_user[$db_temp->entry['user']]['nickname'], $this_tag);
			$this_tag= str_replace("%email%", encodemail($global_user[$db_temp->entry['user']]['email']), $this_tag);
			$this_tag= str_replace("%emailtonick%", encodemail_link($global_user[$db_temp->entry['user']]['email'], $global_user[$db_temp->entry['user']]['nickname']), $this_tag);

			// These will be deprecated, and moved to their respective snippets..
			$this_tag= str_replace("%commlink%", $commlink, $this_tag);
			$this_tag= str_replace("%link%", $permalink, $this_tag); // deprecated
			$this_tag= str_replace("%permalink%", $permalink, $this_tag);
			$this_tag= str_replace("%commcount%", $commcount, $this_tag);
			$this_tag= str_replace("%commnames%", $commnames, $this_tag);

			if (strpos($this_tag, "%introduction-strip%")>0) {
				//debug("%introduction-strip%");
				$stripped=strip_tags($db_temp->entry["introduction"],"<a><b><i><u><embed><strong><ol><li><ul>");
				$stripped="<mode=br><mode=escaped>".$stripped."<mode=nobr><mode=literal>";
				$this_tag= str_replace("%introduction-strip%", $stripped, $this_tag);
			}
							
			$output.=$this_tag;

			if  ( (isset($global_pref['rss'])) && ($global_pref['rss']!="") ) { 
				add_rss($db_temp->entry["code"], $db_temp->entry["title"], xml2html($db_temp->entry["introduction"]), $global_user[$db_temp->entry["user"]]['nickname'] ); 
			}
			
			$db_temp->setpointer("prev");
			
			// check if we need to do some more..
			if ( ($i==($show-1)) || ($i>100) ) { break; }
		} else {
			debug("weblog: else");

			$db_temp->setpointer("prev");
			$show++;

			// check if we need to do some more..
			if ( ($i==($show-1)) || ($i>100) ) { break; }
		}
	}


	return $output;

}


function cms_tag_comments($tag_attr, $tag_default){
	global $db, $global_pref, $row, $block;

	// load the functions for ip-blocking, if necessary..
	include_once "module_ipblock.php";

	$content_code=get_attr_value('content_code', $tag_attr);
	$nocomments=get_attr_value('ifnocomments', $tag_attr);
	$comments=get_attr_value('ifcomments', $tag_attr);
	$entrydate=get_attr_value('entrydate', $tag_attr);

	$global_pref['commentsarr']=explode("|",$global_pref['comments']);
	// there should be code padding here..
	if ($content_code=="") { $content_code=$row["code"]; }

	$content_code=add_code_padding($content_code);	
	
	$output='<a name="comm"></a>';

	$last_comment="";
	$counter=0;

	if ((isset($db->entry['comments']))&&(count($db->entry['comments'])>0)) {
		foreach ($db->entry['comments'] as $temp_row) {


			// this is a record we have to output in some form..

			if ( ($temp_row["ip"].$temp_row["comment"]!=$last_comment) && (!(ip_check_block($temp_row["ip"]))) ){

				if (isemail($temp_row["email"])) {
					$email_format="(".encodemail_link($temp_row["email"], "email", $temp_row["name"]).")";
				} else {
					$email_format="";
				}
				if (isurl($temp_row["url"])) {
					if (strpos($temp_row["url"], "ttp://") < 1 ) {
						$temp_row["url"]="http://".$temp_row["url"];
					}
					$target= ($global_pref['targetblank']) ? " target='_blank'" : "";
					$url_format=sprintf("(<a href='%s' $target title='%s'>link</a>)", $temp_row["url"], strip_tags($temp_row["url"]));
				} else {
					$url_format="";
				}


				$this_tag= $tag_default;
				
				//$this_tag= str_replace("%uid%", $temp_row["uid"], $this_tag);
				$this_tag= str_replace("%ip%", $temp_row["ip"], $this_tag);
				$this_tag= str_replace("%date%", format_date($temp_row["date"],$entrydate), $this_tag);
				$this_tag= str_replace("%comment%", comment_format($temp_row["comment"]), $this_tag);
				$this_tag= str_replace("%name%", stripslashes($temp_row["name"]), $this_tag);
				$this_tag= str_replace("%email%", $email_format, $this_tag);
				$this_tag= str_replace("%url%", $url_format, $this_tag);

				$output.=$this_tag;
				$counter++;
				$last_comment=$temp_row["ip"].$temp_row["comment"];

			}
		}
	}

	$comm_ind = sprintf("<p>%s</p>", $global_pref['commentsarr'][min(2,$counter)], $counter);	
	$comm_ind = str_replace("%num%", $counter, $comm_ind);
	$output = $comm_ind . $output;

	return $output;
}


// comments_linklist() returns a string
// This function is not used anymore..
function cms_tag_commentslist($tag_attr, $tag_default){

	global $db, $global_pref, $row;
	
	if ($content_code=="") { $content_code=$db->entry["code"]; }
	$content_code=rem_code_padding($content_code);	
			
	$table_comments=$global_pref["table_comments"];
	$query="SELECT * FROM $table_comments where content_code='$content_code' order by uid";
	$result = mysql_query($query,$db);
	
	$output="(commentslist)";
	
	if($temp_row = mysql_fetch_array($result)) {
		do {

			
			$output.=sprintf("%s: <b><a href='#comm%s'>%s</a></b>, %s, %s<br>\n",   $temp_row[date],$temp_row[uid], $temp_row[name], $temp_row[content_code], $temp_row[thread_code]);

			
		} while ($temp_row = mysql_fetch_array($result));
	} else {
		// no rows were found..
		$output="(nocomments)$nocomment";
	}

	return $output;

}



// this function will replace a portion of a string $text
// with x's starting at position $leftpos through to position $rightpos
// $text is passed by reference...
function blankout(&$text, $leftpos, $rightpos) {
	while ($leftpos<=$rightpos) {
		$text[$leftpos]="x";
		$leftpos++;
	}
}






?>
